#ifndef CART_ITEM_H
#define CART_ITEM_H

#include <gtk/gtk.h>
#include <libsoup/soup.h>
#include "scanner.h"
#include "yacos_api.h"

G_BEGIN_DECLS
G_DECLARE_FINAL_TYPE(YacosCartItem, yacos_cart_item, YACOS, CART_ITEM, GtkListBoxRow)

#define TYPE_YACOS_CART_ITEM (yacos_cart_item_get_type())

typedef enum _yacos_cart_item_status {
	YACOS_CART_ITEM_STATUS_PENDING = 0,
	YACOS_CART_ITEM_STATUS_VALID,
	YACOS_CART_ITEM_STATUS_INVALID
} yacos_cart_item_status;

GtkWidget *yacos_cart_item_new(void);
void yacos_cart_item_set_id(YacosCartItem *self, yacos_tag_id tag_id);
void yacos_cart_item_fetch_meta(YacosCartItem *self);
void yacos_cart_item_fetch_image(YacosCartItem *self);
yacos_tag_id yacos_cart_item_get_id(YacosCartItem *self);
void yacos_cart_item_set_yacos_api(YacosCartItem *self, YacosApi *api);

G_END_DECLS

#endif // CART_ITEM_H
