#ifndef YACOS_API_H
#define YACOS_API_H

#include <glib-object.h>
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include "scanner.h"

G_BEGIN_DECLS

#define YACOS_TYPE_API yacos_api_get_type()
G_DECLARE_FINAL_TYPE(YacosApi, yacos_api, YACOS, API, GObject)

typedef void (*YacosApiCallback) (guint status, JsonParser *parser, gpointer user_data);

YacosApi *yacos_api_new(void);
void yacos_api_fetch_meta(YacosApi *api,
			  yacos_tag_id tag_id,
			  YacosApiCallback cb,
			  gpointer user_data);
void yacos_api_fetch_image(YacosApi *api,
			   yacos_tag_id tag_id,
			   SoupSessionCallback cb,
			   gpointer user_data);

G_END_DECLS

#endif // YACOS_API_H
